//
// C++ Implementation: porcelainhandler
//
// Description:
//
//
// Author: Remi Villatel <maxilys@tele2.fr>, (C) 2005
//
// Copyright: See COPYING file that comes with this distribution
//
//

#include "porcelainhandler.h"
#include "porcelainclient.h"
#include "pixmaps.h"
#include "embeddata.h"

bool PorcelainHandler::m_initialized = false;
int PorcelainHandler::m_titleSize = 30;
int PorcelainHandler::m_borderSize = (m_titleSize/4)-1;
int PorcelainHandler::m_buttonSize = (m_titleSize/2)+6;
int PorcelainHandler::m_buttonSpacing = 2;
bool PorcelainHandler::m_invertButton = false;
bool PorcelainHandler::m_centerTitle = false;

PorcelainHandler::PorcelainHandler()
{
	reset(0);
}

PorcelainHandler::~PorcelainHandler()
{
	Pixmaps::deletePixmaps();
	qCleanupImages_KWinPorcelain();
	m_initialized = false;
}

bool PorcelainHandler::reset(unsigned long) // unsigned long changed
{
	readConfig();

	Pixmaps::deletePixmaps();
	Pixmaps::createPixmaps();
	qInitImages_KWinPorcelain();

	m_initialized = true;
	return true;
}

KDecoration* PorcelainHandler::createDecoration(KDecorationBridge *bridge)
{
	return new PorcelainClient(bridge, this);
}

void PorcelainHandler::readConfig()
{
	KConfig config("kwinporcelainrc");
	config.setGroup("General");

	m_invertButton = config.readBoolEntry("InvertButton", false);
	m_centerTitle = config.readBoolEntry("CenterTitle", false);

	m_titleSize = config.readNumEntry("TitleSize", 30);
	if (m_titleSize < 28) m_titleSize = 28;
	if (m_titleSize > 48) m_titleSize = 48;

	m_borderSize = (m_titleSize/4)-1;
	m_buttonSize = (m_titleSize/2)+6;
	m_buttonSpacing = 2;

}

#include "porcelainhandler.moc"
